import random

import numpy

from algorithm.pla.perceptron import Perceptron
from algorithm.pla.perceptron_learning_algorithm import train
from aufgaben.p4.testdata import get_labeled_testdata, CLASS_JOGGEN, CLASS_KNIEBEUGE
from aufgaben.p6.error_rate import ErrorRate


def apply_pla():
    test_data, training_data = get_labeled_testdata()

    # Erstelle ein Perzeptron
    weights = [random.random()]
    threshold = 0.5
    perceptron = Perceptron(weights, threshold, numpy.sign)

    # Trainiere das Perzeptron
    train(perceptron, training_data, 1000, 0.1)

    # Vergleiche alle Ergebnisse mit der erwarteten Klasse
    fehlerrate = ErrorRate()
    for features, correct_class in test_data:
        result = perceptron.classify(features)
        fehlerrate.evaluate(correct_class, result)
    fehlerrate.print_table()

    # Berechne den Grenzwert, ab wann ein Feature anders eingeordnet wird
    grenzwert = - perceptron.weights[0] / perceptron.weights[1]

    joggen_test_data = filter(lambda pair: pair[1] == CLASS_JOGGEN, test_data)
    kniebeuge_test_data = filter(lambda pair: pair[1] == CLASS_KNIEBEUGE, test_data)

    return [i[0] for i in joggen_test_data], [i[0] for i in kniebeuge_test_data], grenzwert


if __name__ == '__main__':
    apply_pla()
    # apply_pocket()
